<?php 
class WCCM_BulkEmail
{
	var $mail_message_outcome;
	var $message_type;
	var $render_button;
	public function __construct()
	{
		$this->message_type = "updated";
	}
	
	public function send($args)
	{
		if(!$args || $args == 'none')
		{
			$this->mail_message_outcome =  esc_html__('Error: please select at least one recipient.', 'woocommerce-customers-manager');
			 $this->message_type = "error";
			return;
		}
		global $wpdb;
		$query_string = "SELECT * FROM {$wpdb->users} WHERE ID IN (".$args.")";
		
		$users = $wpdb->get_results($query_string);
		foreach($users as $user)
		{
			$mail = new WCCM_Email();
			$mail->trigger($user->user_email, $_POST['mail_subject'], $_POST['mail_text'], "notification", $user->ID);
		}
		 $this->mail_message_outcome =  esc_html__('Your message has been successfully sent.', 'woocommerce-customers-manager');
		 $this->message_type = "updated";
	}
	public function get_ids_and_emails($customer_ids)
	{
		global $wpdb;
		$query_string = "SELECT ID, user_email FROM {$wpdb->users} WHERE ID IN (".$customer_ids.") GROUP BY ID";
		$id_emails = $wpdb->get_results($query_string);
		return $id_emails;
	}
	public static function force_dequeue_scripts($enqueue_styles)
	{
		if ( class_exists( 'woocommerce' ) && isset($_GET['page']) && $_GET['page'] == 'wccm-bulk-email-customer') 
		{
			global $wp_scripts;
			$wp_scripts->queue = array();
			WCCM_BulkEmail::enqueue_scripts();

		} 
	}
	public static function enqueue_scripts()
	{
		if ( class_exists( 'woocommerce' ) && isset($_GET['page']) && $_GET['page'] == 'wccm-bulk-email-customer') 
		{
			wp_enqueue_script('jquery') ;
			wp_enqueue_script('jquery-ui-core') ;
			wp_enqueue_script('jquery-ui-slider') ;
			wp_enqueue_script('jquery-ui-progressbar');
			
		}
	}
	public function render_page()
	{
		wp_enqueue_style('wccm-common', WCCM_PLUGIN_PATH.'/css/common.css');   
		wp_enqueue_style('bulkemail-css', WCCM_PLUGIN_PATH.'/css/bulkemail.css'); 
		//ids set by customers list view
		$customer_ids = isset($_REQUEST["customer"]) ? implode(",", $_REQUEST["customer"]):"none";
		//come from same view
		$customer_ids = isset($_REQUEST["customer_ids"]) ? implode(",",$_REQUEST["customer_ids"]):$customer_ids;
		$this->render_button = true;
		
		$customer_ids_email = null;
		if($customer_ids != 'none')
		{
			$customer_ids_email = $this->get_ids_and_emails($customer_ids);
		}
		
		if(isset($_REQUEST["send_bulk_mail"]))
		{
			$this->send($customer_ids);
		}
		
		//Results
		if($customer_ids == "none" && ( !isset($_GET['page']) || $_GET['page'] != 'wccm-bulk-email-customer'))
		{
			$this->render_button = false;
			echo '<div id="message" class="error"><ul>';
				
					echo '<li>' . esc_html__('Error: please select at least one recipient', 'woocommerce-customers-manager')  . '</li>';
			echo '</ul></div>';
		}			
		else if ( ! empty( $this->mail_message_outcome ) ) 
		{
			echo '<div id="message" class="'.$this->message_type.'"><ul>';
				
					echo '<li>' . $this->mail_message_outcome  . '</li>';
			echo '</ul></div>';
		}
		
		
		wp_enqueue_style( 'wccm-select2-style',  WCCM_PLUGIN_PATH.'/css/select2.min.css' ); 
		
		wp_enqueue_script( 'wccm-select2-script', WCCM_PLUGIN_PATH.'/js/select2.min.js', array('jquery') );
		wp_enqueue_script( 'wccm-customer-ajax-autocomplete',WCCM_PLUGIN_PATH.'/js/admin-bulk-email-customer-autocomplete.js', array('jquery') );
		?>
		
		
		<h2 id="add-new-user"> 
						<?php  esc_html_e('Bulk emails', 'woocommerce-customers-manager');?> 
			</h2>
		<div id="bulk-email-box">
				<p>
					<form name="send-mail-form" method="post" action="">
						<input type="hidden" value="true" name="send_bulk_mail"></input>
						<input type="hidden" value="wccm-bulk-email-customer" name="action"></input>
						<h4 class="wccm_no_margin_top"><?php  esc_html_e('Customers', 'woocommerce-customers-manager');?></h4>
						<p><?php  esc_html_e('You can search typing name, last name or email', 'woocommerce-customers-manager');?></p>
						<select class="js-data-customers-ajax" name="customer_ids[]" id="customer_ids" multiple="multiple"> 
						
						<?php if(isset($customer_ids_email)) 
								foreach($customer_ids_email as $customer) 
								echo '<option value="'.$customer->ID.'" selected="selected">'.$customer->user_email.'</option>'; 
						?>
						</select>
						
						
						<h4><?php  esc_html_e('Subject', 'woocommerce-customers-manager'); ?></h4> 
						<input type="text" style="width:350px;" name="mail_subject"></input>
						<h4><?php  esc_html_e('Text', 'woocommerce-customers-manager'); ?></h4> 
						<p><?php  wccm_html_escape_allowing_special_tags(__('HTML code is allowed only if the visual editor has been disable in the Options menu. Use <strong>{first_name}</strong>, <strong>{last_name}</strong>, <strong>{user_email}</strong>, <strong>{billing_first_name}</strong>, <strong>{billing_last_name}</strong>, <strong>{billing_email}</strong>, <strong>{shipping_first_name}</strong>, <strong>{shipping_last_name}</strong> placeholders to render user first and last names in the email body.', 'woocommerce-customers-manager')); ?></p>
						<?php if(WCCM_Options::get_option('disable_email_visual_editor') === 'true'): ?>
						<textarea style="clear:both" cols="70" rows="12"   name="mail_text" id="mail_text"></textarea>
						<?php else: ?>
						<?php  wp_editor( "", "mail_text", array( 'media_buttons' => false,
																   'textarea_rows' => 10,
																   'tinymce' => true,
																   "wpautop" => false,
																   'textarea_name'=>"mail_text")); 
						endif;?>
																							   
						<p class="submit">
						<?php ?>
						<input class="button-primary" type="submit" value=" <?php esc_html_e('Send email', 'woocommerce-customers-manager' ); ?>"> </input>
						<?php  ?>
						</p>
					</form>
				</p>
		</div>
		<?php
	}
	private function var_debug($var)
	{
		echo "<pre>";
		var_dump($var);
		echo "</pre>";
	}

}
?>