<?php 
class WCCM_CustomerAdd
{

	var $error;
	var $messages;
	var $edit_mode;
	 public function __construct($edit_mode = false)
	 {
		$this->messages = array();
		$this->edit_mode = $edit_mode;
	 }
	 
	 private function get_user_data($id)
	 {
		 $result = array();
		 $customer_info = get_userdata($id );
		 $customer_extra_info = get_user_meta($id);
		 
		
		 $result['user_login'] = $customer_info->user_login;
		 $result['first_name'] = $customer_info->first_name;
		 $result['last_name'] = $customer_info->last_name;
		 $result['email'] = $customer_info->user_email;
		 $result['ID'] = $id;
		 $result['roles'] = $customer_info->roles;
		 
		
		 if(isset($customer_extra_info['billing_first_name']))
			$result['billing_first_name'] = str_replace('"', "'", $customer_extra_info['billing_first_name'][0]);
		 if(isset($customer_extra_info['billing_last_name']))
			$result['billing_last_name'] = str_replace('"', "'", $customer_extra_info['billing_last_name'][0]);
		 if(isset($customer_extra_info['billing_phone']))
			$result['billing_phone'] = $customer_extra_info['billing_phone'][0]; 
		if(isset($customer_extra_info['billing_email']))
			$result['billing_email'] = $customer_extra_info['billing_email'][0];
		 if(isset($customer_extra_info['billing_company']))
			$result['billing_company'] = str_replace('"', "'", $customer_extra_info['billing_company'][0]);
		if(isset($customer_extra_info['billing_eu_vat']))
			$result['billing_eu_vat'] = str_replace('"', "'", $customer_extra_info['billing_eu_vat'][0]);
		if(isset($customer_extra_info['billing_it_sid_pec']))
			$result['billing_it_sid_pec'] = str_replace('"', "'", $customer_extra_info['billing_it_sid_pec'][0]);
		if(isset($customer_extra_info['billing_it_codice_fiscale']))
			$result['billing_it_codice_fiscale'] = str_replace('"', "'", $customer_extra_info['billing_it_codice_fiscale'][0]);
		 if(isset($customer_extra_info['billing_address_1']))
			$result['billing_address_1'] = str_replace('"', "'",$customer_extra_info['billing_address_1'][0]);
		 if(isset($customer_extra_info['billing_address_2']))
			$result['billing_address_2'] =str_replace('"', "'", $customer_extra_info['billing_address_2'][0]);
		 if(isset($customer_extra_info['billing_postcode']))
			$result['billing_postcode'] = $customer_extra_info['billing_postcode'][0];
		 if(isset($customer_extra_info['billing_city']))
			$result['billing_city'] = $customer_extra_info['billing_city'][0];
		
		$result['billing_state'] = isset($customer_extra_info['billing_state']) ? $customer_extra_info['billing_state'][0] : "";
		$result['billing_country'] = isset($customer_extra_info['billing_state']) ? $customer_extra_info['billing_country'][0] : "";
		
		if(isset($customer_extra_info['shipping_first_name']))
			$result['shipping_first_name'] = str_replace('"', "'", $customer_extra_info['shipping_first_name'][0]);
		if(isset($customer_extra_info['shipping_last_name']))
			$result['shipping_last_name'] = str_replace('"', "'", $customer_extra_info['shipping_last_name'][0]);
		 if(isset($customer_extra_info['shipping_phone']))
			$result['shipping_phone'] = $customer_extra_info['shipping_phone'][0];
		 if(isset($customer_extra_info['shipping_company']))
			$result['shipping_company'] = str_replace('"', "'", $customer_extra_info['shipping_company'][0]); 
		 if(isset($customer_extra_info['shipping_address_1']))
			$result['shipping_address_1'] = str_replace('"', "'", $customer_extra_info['shipping_address_1'][0]);
		 if(isset($customer_extra_info['shipping_address_2']))
			$result['shipping_address_2'] = str_replace('"', "'", $customer_extra_info['shipping_address_2'][0]);
		 if(isset($customer_extra_info['shipping_postcode']))
			$result['shipping_postcode'] = $customer_extra_info['shipping_postcode'][0];
		 if(isset($customer_extra_info['shipping_city']))
			$result['shipping_city'] = $customer_extra_info['shipping_city'][0];
		
		 $result['shipping_country'] = isset($customer_extra_info['shipping_country']) ? $customer_extra_info['shipping_country'][0] : ""; 
		 $result['shipping_state'] = isset($customer_extra_info['shipping_country']) ? $customer_extra_info['shipping_state'][0] : "";
		 
		 return $result;
	 }
	 
	 private function update_user()
	 {
		 $this->error = null;
		 $mail_exists_id = email_exists($_REQUEST[ 'email' ]);
		
		$user_id = 0;
		if($_REQUEST[ 'pass1' ] != $_REQUEST[ 'pass2' ])
			$this->error = new WP_Error('empty', esc_html__('Password mismatch', 'woocommerce-customers-manager'));
		else if(isset($mail_exists_id) && $mail_exists_id != false && $mail_exists_id != $_REQUEST[ 'ID' ])
			$this->error = new WP_Error('empty', esc_html__('Mail already taken', 'woocommerce-customers-manager'));
		else
		{
			
			$args = array( 'ID' => $_REQUEST[ 'ID' ], 
						  'user_email' => $_REQUEST[ 'email' ],
						  'first_name' => isset($_REQUEST['first_name']) ? $_REQUEST['first_name']:"",
					      'last_name' => isset($_REQUEST['last_name']) ? $_REQUEST['last_name']:"");
			
			$user_id = wp_update_user($args );
			
			if(!empty($_REQUEST[ 'pass1' ]))
				wp_set_password( $_REQUEST[ 'pass1' ], $_REQUEST[ 'ID' ]);
		
			if(is_wp_error( $user_id ))
			{
				 $this->error = $result->get_error_message();
				 return;
			}
			//metadata
			$this->updata_user_meta($user_id, $_REQUEST);
			
			$this->messages = array(0 => esc_html__('Customer updated!', 'woocommerce-customers-manager'));
		}
		return $user_id;
	 }
	 private function add_user()
	 {
		 $this->error = null;
		 $user_id = null;
		
		if(wccm_get_value_if_set($_REQUEST, 'random_generate_password'. false))
		{
			$_REQUEST[ 'pass1' ] = $_REQUEST[ 'pass2' ] = rand (10000000,28000000);
		}
	
		if(empty($_REQUEST[ 'pass1' ]) || empty($_REQUEST[ 'pass2' ]) || empty($_REQUEST[ 'email' ]))
			$this->error = new WP_Error('empty', esc_html__('Email and password fields cannot be empty', 'woocommerce-customers-manager'));
		else if($_REQUEST[ 'pass1' ] != $_REQUEST[ 'pass2' ])
			$this->error = new WP_Error('empty', esc_html__('Password mismatch', 'woocommerce-customers-manager'));
		else
		{
			$user_email = isset($_REQUEST[ 'email' ]) ? $_REQUEST[ 'email' ] : "";
			$user_id = username_exists( $_REQUEST[ 'user_login' ] );
			if ( !$user_id and email_exists($user_email) == false) 
			{
				$userdata = array(
					'user_login'  =>  $_REQUEST[ 'user_login' ],
					'user_pass'   =>  $_REQUEST[ 'pass1' ],
					'user_email' => $_REQUEST[ 'email' ],
					'first_name' => isset($_REQUEST['first_name']) ? $_REQUEST['first_name']:"",
					'last_name' => isset($_REQUEST['last_name']) ? $_REQUEST['last_name']:""
				);
				$user_id = wp_insert_user($userdata);
				wp_set_password( $_REQUEST[ 'pass1' ], $user_id);
				//metadata
				$this->updata_user_meta($user_id, $_REQUEST);
				if(isset($_POST['wccm-send-notification-email']) && $_POST['wccm-send-notification-email'] == 'yes')
				{
					$mail = new WCCM_Email();
					$mail->send_new_user_notification_email($_REQUEST[ 'email' ], $_REQUEST['user_login'], $_REQUEST['pass1'], $user_id);
				}
			}
			else
			{
				$this->error = new WP_Error('password', esc_html__('User mail already registered', 'woocommerce-customers-manager'));
			}
			if(!isset($this->error))
			{
				if(is_wp_error( $user_id ))
				{
						$this->error = $user_id;
						$user_id = null;
				}
				else
					$this->messages = array(0 => esc_html__('Customer added!', 'woocommerce-customers-manager'));
			}
		}
		
		return $user_id;
	 }
	 
     private function updata_user_meta($user_id, $data_source)
	 {
		  global $wpdb, $wccm_customer_model;
		
	    $data_source['roles'] = !isset($data_source['roles']) ? 'customer' : $data_source['roles'];
		$roles_temp = array();
		if(!is_array($data_source['roles']))
			$roles_temp[$data_source['roles']] = true;
		else
			foreach($data_source['roles'] as $role_code)
				$roles_temp[$role_code] = true;
		
		
		$wccm_customer_model->update_user_meta( $user_id, $wpdb->prefix.'capabilities', $roles_temp );
		$wccm_customer_model->update_user_meta( $user_id, 'billing_first_name', $data_source['billing_first_name'] );
		$wccm_customer_model->update_user_meta( $user_id, 'billing_last_name', $data_source['billing_last_name'] );
		$wccm_customer_model->update_user_meta( $user_id, 'billing_email', $data_source['billing_email'] );
		$wccm_customer_model->update_user_meta( $user_id, 'billing_phone', $data_source['billing_phone'] );
		$wccm_customer_model->update_user_meta( $user_id, 'billing_company', $data_source['billing_company'] );
		if(isset($data_source['billing_eu_vat']))
			$wccm_customer_model->update_user_meta( $user_id, 'billing_eu_vat', $data_source['billing_eu_vat'] );
		if(isset($data_source['billing_it_sid_pec']))
			$wccm_customer_model->update_user_meta( $user_id, 'billing_it_sid_pec', $data_source['billing_it_sid_pec'] );
		if(isset($data_source['billing_it_codice_fiscale']))
			$wccm_customer_model->update_user_meta( $user_id, 'billing_it_codice_fiscale', $data_source['billing_it_codice_fiscale'] );
		$wccm_customer_model->update_user_meta( $user_id, 'billing_address_1', $data_source['billing_address_1'] );
		$wccm_customer_model->update_user_meta( $user_id, 'billing_address_2', $data_source['billing_address_2'] );
		$wccm_customer_model->update_user_meta( $user_id, 'billing_postcode', $data_source['billing_postcode'] );
		$wccm_customer_model->update_user_meta( $user_id, 'billing_city', $data_source['billing_city'] );
		$wccm_customer_model->update_user_meta( $user_id, 'billing_state', $data_source['billing_state'] );
		$wccm_customer_model->update_user_meta( $user_id, 'billing_country', $data_source['billing_country'] );
		
		if(isset($data_source['shipping_as_billing']) && $data_source['shipping_as_billing'] == 'yes')	
		{
			$data_source['shipping_first_name'] = $data_source['billing_first_name'];
			$data_source['shipping_last_name'] = $data_source['billing_last_name'];
			$data_source['shipping_phone'] = $data_source['billing_phone'];
			$data_source['shipping_company'] = $data_source['billing_company'];
			$data_source['shipping_address_1'] =  $data_source['billing_address_1'];
			$data_source['shipping_address_2'] =  $data_source['billing_address_2'];
			$data_source['shipping_postcode'] =  $data_source['billing_postcode'];
			$data_source['shipping_city'] = $data_source['billing_city'];
			$data_source['shipping_state'] = $data_source['billing_state'];
			$data_source['shipping_country'] = $data_source['billing_country'];
		}
		$wccm_customer_model->update_user_meta( $user_id, 'shipping_first_name', $data_source['shipping_first_name'] );
		$wccm_customer_model->update_user_meta( $user_id, 'shipping_last_name', $data_source['shipping_last_name'] );
		$wccm_customer_model->update_user_meta( $user_id, 'shipping_phone', $data_source['shipping_phone'] );
		$wccm_customer_model->update_user_meta( $user_id, 'shipping_company', $data_source['shipping_company'] );
		$wccm_customer_model->update_user_meta( $user_id, 'shipping_address_1', $data_source['shipping_address_1'] );
		$wccm_customer_model->update_user_meta( $user_id, 'shipping_address_2', $data_source['shipping_address_2'] );
		$wccm_customer_model->update_user_meta( $user_id, 'shipping_postcode', $data_source['shipping_postcode'] );
		$wccm_customer_model->update_user_meta( $user_id, 'shipping_city', $data_source['shipping_city'] );
		$wccm_customer_model->update_user_meta( $user_id, 'shipping_state', $data_source['shipping_state'] );
		$wccm_customer_model->update_user_meta( $user_id, 'shipping_country', $data_source['shipping_country'] );
		
		if(WCCM_Options::get_option('actions_profile_update', false))
		{
			$old_user_data = get_userdata( $user_id );
			do_action('profile_update', $user_id, $old_user_data);
		}
	 }
	 
	 public function render_page()
	 {
		global $wccm_customer_model, $wpuef_htmlHelper, $wpuef_user_model, $wccm_html_model, $wccm_order_model;
		$countries = new WC_Countries();
		
		
		if(!$this->edit_mode)
		{
			$data_source = $_REQUEST;
			if(isset($data_source['user_login']) == true)
			{
				$user_id = $this->add_user();
				if(isset($_POST['wccm_order_to_assign']) && isset($user_id)) //Assign order to user save process
				{
					$order_ids = $_POST['wccm_order_to_assign'];
					$additional_params = array('overwrite_billing_data' => isset($_POST['wccm_order_to_assign_overwrite_billing_data']), 'overwrite_shipping_data' => isset($_POST['wccm_order_to_assign_overwrite_shipping_data']));
				
					$wccm_order_model->assign_users($order_ids, $user_id, $additional_params);
				}
			}
			elseif(WCCM_Options::get_option('add_customer_page_automatic_username_generation', false))
			{
				$data_source['user_login'] = wccm_generate_random_string();
			}
		}
		else
		{
			if(isset($_REQUEST['user_login']) == true)
			{
				$user_id = $this->update_user($_REQUEST['customer']);
				$data_source = $user_id > 0 ? $this->get_user_data($user_id ) : $_REQUEST;//$_REQUEST;
			}
			else
				$data_source = $this->get_user_data($_REQUEST['customer']);
		}
		
		$js_country = array();
		foreach($countries->get_allowed_countries() as $country_code => $country_name)
				$js_country[$country_code] = [ 'name' => $country_name, 'states' => [] ];
				 
				
		foreach($countries->get_allowed_countries() as $country_code => $country_name)
		{
		
			$states = $countries->get_states($country_code);
			if( $states)
				foreach ($countries->get_states($country_code) as $state_code => $state_name)
					$js_country[$country_code]["states"][$state_code] = $state_name;
		}
						
		wp_register_script('wccm-add-user-page', WCCM_PLUGIN_PATH . '/js/admin-add-user-page.js', array( 'jquery'));
		$js_options = array('automatically_generate_password' => WCCM_Options::get_option('add_customer_page_automatic_password_generation', false),
							'automatically_fill_billing_first_name' => WCCM_Options::get_option('add_customer_page_billing_first_name_automatic_filling', false),
							'automatically_fill_billing_last_name' => WCCM_Options::get_option('add_customer_page_billing_last_name_automatic_filling', false),
							'automatically_fill_billing_email' => WCCM_Options::get_option('add_customer_page_billing_email_automatic_filling', false),
							'countries' => $js_country,
							'selected_shipping_country' => isset($data_source[ 'shipping_country' ]) ? $data_source[ 'shipping_country' ] : "",
							'selected_billing_country' => isset($data_source[ 'billing_country' ]) ? $data_source[ 'billing_country' ] : "",
							'selected_shipping_state' => isset($data_source[ 'shipping_state' ]) ? $data_source[ 'shipping_state' ] : "",
							'selected_billing_state' => isset($data_source[ 'billing_state' ]) ? $data_source[ 'billing_state' ] : "",
							);
		wp_localize_script( 'wccm-add-user-page', 'wccm', $js_options );
		wp_enqueue_script( 'wccm-add-user-page' );
		wp_enqueue_script( 'wccm-select2-script', WCCM_PLUGIN_PATH.'/js/select2.min.js', array('jquery') );
		
		wp_enqueue_style('wccm-common', WCCM_PLUGIN_PATH.'/css/common.css');   
		wp_enqueue_style('customer-add-css', WCCM_PLUGIN_PATH.'/css/customer-add.css'); 
		wp_enqueue_style( 'wccm-select2-style',  WCCM_PLUGIN_PATH.'/css/select2.min.css'); 
		?>
		
		<div id="wpbody">
		
			<div tabindex="0" aria-label="Main content" id="wpbody-content">
					
							
					
			<h2 id="add-new-user"> 
			<?php  if($this->edit_mode)
						_e('Edit customer', 'woocommerce-customers-manager');
					else
						_e('Add new customer', 'woocommerce-customers-manager');
			?> 
			
			<?php $url =  get_admin_url()."?page=woocommerce-customers-manager";
			if($this->edit_mode && isset($_GET['back']))
			{
				$url =  get_admin_url()."?page=woocommerce-customers-manager&customer=".$_GET['customer']."&action=customer_details";
			}
			?>
			<small class="wc-admin-breadcrumb"><a href="<?php echo $url; ?>" title="<?php esc_html_e('Go back', 'woocommerce-customers-manager') ?>">
				<img draggable="false" class="emoji" alt="Back" src="https://s.w.org/images/core/emoji/2/svg/2934.svg"></a>
			</small>
			</h2>
			<?php if ( isset($this->error) && is_wp_error( $this->error) ) : ?>
				<div class="error">
					<ul>
					<?php
						foreach ( $this->error->get_error_messages() as $err )
							echo "<li>$err</li>\n";
					?>
					</ul>
				</div>
			<?php endif;

			if ( ! empty( $this->messages ) ) {
				echo '<div id="message" class="updated"><ul>';
					foreach ( $this->messages as $msg )
						echo '<li>' . $msg . '</li>';
				echo '</ul></div>';
			} ?>

			<?php if ( isset($add_user_errors) && is_wp_error( $add_user_errors ) ) : ?>
				<div class="error">
					<?php
						foreach ( $add_user_errors->get_error_messages() as $message )
							echo "<p>$message</p>";
					?>
				</div>
			<?php endif; ?>
			<div id="ajax-response"></div>

			<form class="validate" id="createuser" name="createuser" method="post" action="">
				
					<input type="submit" value="<?php 
							if(!$this->edit_mode)
								_e('Add new customer', 'woocommerce-customers-manager');
							else
								_e('Update customer', 'woocommerce-customers-manager');
						?>" class="button button-primary add-update_user-button" name="createuser"></input>
				
				
			<!-- <input type="hidden" value="createuser" name="action">-->
			<input type="hidden" value="<?php //echo $_REQUEST['customer'] ?>" name="customer">
			<?php if(isset($data_source['ID'])):?>
				<input type="hidden" value="<?php echo $data_source[ 'ID' ] ?>" name="ID">
			<?php endif; ?>
			<?php if($this->edit_mode):?>
				<input type="hidden" value="<?php echo $data_source[ 'user_login' ] ?>" name="user_login">
			<?php endif; ?>
			
			<table class="form-table">
				<tbody>
				<tr class="form-field form-required">
					<th scope="row"><label for="user_login">Username <span class="description">(<span class="field_required">required</span>)</span></label></th>
					<td><input required="required" type="text" aria-required="true" value="<?php if(isset($data_source[ 'user_login' ])) echo $data_source[ 'user_login' ];?>" id="user_login" name="user_login" <?php if($this->edit_mode) echo 'disabled';?>></td>
				</tr>
				<tr class="form-field form-required">
					<th scope="row"><label for="email">E-mail <span class="description ">(<span class="field_required">required</span>)</span></label></th>
					<td><input required="required" type="text" value="<?php if(isset($data_source[ 'email' ])) echo $data_source[ 'email' ];?>" id="email" name="email"></td>
				</tr>
				<tr class="form-field">
					<th scope="row"><label for="first_name"><?php esc_html_e('First name', 'woocommerce-customers-manager'); ?> </label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'first_name' ])) echo $data_source[ 'first_name' ];?>" id="first_name" name="first_name"></td>
				</tr>
				<tr class="form-field">
					<th scope="row"><label for="last_name"><?php esc_html_e('Last name', 'woocommerce-customers-manager'); ?> </label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'last_name' ])) echo $data_source[ 'last_name' ];?>" id="last_name" name="last_name"></td>
				</tr>
				<?php if(!$this->edit_mode): ?>
				<tr class="form-field">
					<th scope="row"><label><?php esc_html_e('Random generate password', 'woocommerce-customers-manager'); ?></label></th>
					<td>
						<label class="switch">
						  <input type="checkbox" name="random_generate_password" id="random_generate_password" value="true">
						  <span class="slider round"></span>
						</label>
					</td>
				</tr>
				<?php endif; ?>
				<tr class="form-field wccm-password-row">
					<th scope="row"><label for="pass1">Password <span class="description">(<?php if($this->edit_mode == true) esc_html_e('Leaving it blank will leave password unchanged', 'woocommerce-customers-manager'); else esc_html_e('Required', 'woocommerce-customers-manager');  ?>)</span></label></th>
					<td>
						<input value=" " class="hidden"><!-- #24364 workaround -->
						<input type="password" autocomplete="off" id="pass1" name="pass1" value="">
					</td>
				</tr>
				<tr class="form-field wccm-password-row">
					<th scope="row"><label for="pass2"><?php esc_html_e('Repeat Password', 'woocommerce-customers-manager'); if(!$this->edit_mode) echo '<span class="description"> (Required)</span>' ?> </label></th>
					<td>
						<input type="password" autocomplete="off" id="pass2" name="pass2" value="">
					</td> 
				</tr>
								
				<tr class="form-field">
					<th scope="row"><label for="roles"><?php esc_html_e('Roles', 'woocommerce-customers-manager'); ?> <span class="description ">(<span class="field_required">required</span>)</span></label></th>
					<td>
					<select name="roles[]" class="js-role-select"  multiple="multiple" required="required">
					<?php 
							global $wp_roles;
							foreach( $wp_roles->roles as $role_code => $role_data)
							{
								$selected = '';		
								if($role_code != 'administrator')
								{
									if(!$this->edit_mode && $role_code == "customer")
										$selected = ' selected="selected" ';
									else if(isset($data_source[ 'roles' ]))
										 foreach($data_source[ 'roles' ] as $user_role)
											 if( $user_role == $role_code)
														$selected = ' selected="selected" ';
											
									echo '<option value="'.$role_code.'" '.$selected.'>'.$role_data['name'].'</option>';
								}
							}
						?>
						</select>
					</td>
				</tr>
				
				<tr class="form-field">
					<th scope="row"><label for="billing_first_name"><?php esc_html_e('Billing first name', 'woocommerce-customers-manager'); ?> </label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'billing_first_name' ])) echo $data_source[ 'billing_first_name' ];?>" id="billing_first_name" name="billing_first_name"></td>
				</tr>
				<tr class="form-field">
					<th scope="row"><label for="billing_last_name"><?php esc_html_e('Billing last name', 'woocommerce-customers-manager'); ?> </label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'billing_last_name' ])) echo $data_source[ 'billing_last_name' ];?>" id="billing_last_name" name="billing_last_name"></td>
				</tr>
				
				<tr>
					<th  scope="row"><label for="billing_email"><?php esc_html_e('Billing email', 'woocommerce-customers-manager'); ?></label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'billing_email' ])) echo $data_source[ 'billing_email' ];?>" id="billing_email" name="billing_email"></td>
				</tr>
				<tr>
					<th  scope="row"><label for="billing_phone"><?php esc_html_e('Billing phone', 'woocommerce-customers-manager'); ?></label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'billing_phone' ])) echo $data_source[ 'billing_phone' ];?>" id="billing_phone" name="billing_phone"></td>
				</tr>
				<tr>
					<th scope="row"><label for="billing_company"><?php esc_html_e('Billing company', 'woocommerce-customers-manager'); ?></label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'billing_company' ])) echo $data_source[ 'billing_company' ];?>" id="billing_company" name="billing_company"></td>
				</tr>
				
				<?php if($wccm_customer_model->is_vat_field_enabled()): ?>
					<tr class="form-field">
						<th scope="row"><label for="billing_eu_vat"><?php esc_html_e('Billing VAT number', 'woocommerce-customers-manager'); ?></label></th>
						<td><input type="text" value="<?php if(isset($data_source[ 'billing_eu_vat' ])) echo $data_source[ 'billing_eu_vat' ];?>" id="billing_eu_vat" name="billing_eu_vat"></td>
					</tr>
					<tr class="form-field">
						<th scope="row"><label for="billing_it_sid_pec"><?php esc_html_e('Billing SDI / Pec', 'woocommerce-customers-manager'); ?></label></th>
						<td><input type="text" value="<?php if(isset($data_source[ 'billing_it_sid_pec' ])) echo $data_source[ 'billing_it_sid_pec' ];?>" id="billing_it_sid_pec" name="billing_it_sid_pec"></td>
					</tr>
					<tr class="form-field">
						<th scope="row"><label for="billing_it_codice_fiscale"><?php esc_html_e('Billing Codice fiscale', 'woocommerce-customers-manager'); ?></label></th>
						<td><input type="text" value="<?php if(isset($data_source[ 'billing_it_codice_fiscale' ])) echo $data_source[ 'billing_it_codice_fiscale' ];?>" id="billing_it_codice_fiscale" name="billing_it_codice_fiscale"></td>
					</tr>
				<?php endif; ?>
				<tr class="form-field">
					<th scope="row"><label for="billing_address_1"><?php esc_html_e('Billing address', 'woocommerce-customers-manager'); ?></label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'billing_address_1' ])) echo $data_source[ 'billing_address_1' ];?>" id="billing_address_1" name="billing_address_1"></td>
				</tr>
				<tr class="form-field">
					<th scope="row"><label for="billing_address_2"><?php esc_html_e('Apartament, suite, unit, etc.', 'woocommerce-customers-manager'); ?></label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'billing_address_2' ])) echo $data_source[ 'billing_address_2' ];?>" id="billing_address_2" name="billing_address_2"></td>
				</tr>
				<tr class="form-field">
					<th scope="row"><label for="billing_postcode"><?php esc_html_e('Post code', 'woocommerce-customers-manager'); ?></label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'billing_postcode' ])) echo $data_source[ 'billing_postcode' ];?>" id="billing_postcode" name="billing_postcode"></td>
				</tr>
				<tr class="form-field">
					<th scope="row"><label for="billing_city"><?php esc_html_e('Billing city', 'woocommerce-customers-manager'); ?></label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'billing_city' ])) echo $data_source[ 'billing_city' ];?>" id="billing_city" name="billing_city"></td>
				</tr>
				<tr class="form-field">
					<th scope="row"><label for="billing_country"><?php esc_html_e('Billing country', 'woocommerce-customers-manager'); ?></label></th>
					<td>
						<select id="billing_country" name="billing_country">
						</select>
				</td>
				</tr>
				<tr class="form-field">
					<th scope="row"><label for="billing_state"><?php esc_html_e('Billing state', 'woocommerce-customers-manager'); ?></label></th>
					<td id="billing_state_wrapper">
						
					</td>
				</tr>
			
				<tr>
					<th><h3><?php esc_html_e('Shipping info as Billing info?', 'woocommerce-customers-manager'); ?></h3></th>
					<td><input type="checkbox" name="shipping_as_billing" id="shipping_as_billing" value="yes"></input></td>
				</tr>
				<tr  class="wccm-shipping-info">
					<th><h3><?php esc_html_e('Shipping info', 'woocommerce-customers-manager'); ?></h3></th>
					<td></td>
				</tr>
				<tr  class="wccm-shipping-info">
					<th scope="row"><label for="shipping_first_name"><?php esc_html_e('Shipping first name', 'woocommerce-customers-manager'); ?></label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'shipping_first_name' ])) echo $data_source[ 'shipping_first_name' ];?>" id="shipping_first_name" name="shipping_first_name"></td>
				</tr>
				<tr  class="wccm-shipping-info">
					<th scope="row"><label for="shipping_last_name"><?php esc_html_e('Shipping last name', 'woocommerce-customers-manager'); ?></label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'shipping_last_name' ])) echo $data_source[ 'shipping_last_name' ];?>" id="shipping_last_name" name="shipping_last_name"></td>			
				</tr>				
				<tr  class="wccm-shipping-info">
					<th scope="row"><label for="billing_phone"><?php esc_html_e('Shipping phone', 'woocommerce-customers-manager'); ?></label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'shipping_phone' ])) echo $data_source[ 'shipping_phone' ];?>" id="shipping_phone" name="shipping_phone"></td>
				</tr>
				<tr class="wccm-shipping-info">
					<th scope="row"><label for="shipping_company"><?php esc_html_e('Shipping company', 'woocommerce-customers-manager'); ?></label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'shipping_company' ])) echo $data_source[ 'shipping_company' ];?>" id="shipping_company" name="shipping_company"></td>
				</tr>
				<tr class="form-field wccm-shipping-info">
					<th scope="row"><label for="shipping_address_1"><?php esc_html_e('Shipping address', 'woocommerce-customers-manager'); ?></label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'shipping_address_1' ])) echo $data_source[ 'shipping_address_1' ];?>" id="shipping_address_1" name="shipping_address_1"></td>
				</tr>
				<tr class="form-field wccm-shipping-info">
					<th scope="row"><label for="shipping_address_2"><?php esc_html_e('Apartament, suite, unit, etc.', 'woocommerce-customers-manager'); ?></label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'shipping_address_2' ])) echo $data_source[ 'shipping_address_2' ];?>" id="shipping_address_2" name="shipping_address_2"></td>
				</tr>
				<tr class="form-field wccm-shipping-info">
					<th scope="row"><label for="shipping_postcode"><?php esc_html_e('Post code', 'woocommerce-customers-manager'); ?></label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'shipping_postcode' ])) echo $data_source[ 'shipping_postcode' ];?>" id="shipping_postcode" name="shipping_postcode"></td>
				</tr>
				<tr class="form-field wccm-shipping-info">
					<th scope="row"><label for="shipping_city"><?php esc_html_e('Shipping city', 'woocommerce-customers-manager'); ?></label></th>
					<td><input type="text" value="<?php if(isset($data_source[ 'shipping_city' ])) echo $data_source[ 'shipping_city' ];?>" id="shipping_city" name="shipping_city"></td>
				</tr>
				<tr class="form-field wccm-shipping-info">
					<th scope="row"><label for="shipping_country"><?php esc_html_e('Shipping country', 'woocommerce-customers-manager'); ?></label></th>
					<td>
					<select id="shipping_country" name="shipping_country">
						
					</select>
					</td>
				</tr>
				<tr class="form-field wccm-shipping-info">
					<th scope="row"><label for="shipping_state"><?php esc_html_e('Shipping state', 'woocommerce-customers-manager'); ?></label></th>
					<td id="shipping_state_wrapper">
					
					</td>
				</tr>
				
				
				<?php if(!$this->edit_mode): ?>
				<tr class="form-field wccm-shipping-info">
					<th scope="row"><label for=""><?php esc_html_e('Assign orders', 'woocommerce-customers-manager'); ?></label></th>
					<td id="">
						<?php $wccm_html_model->assign_orders_to_user_selector(); ?>
					</td>
				</tr>
				<?php endif; ?>
					
				<tr style="display:none;" class="form-field">
					<th scope="row"><label for="role">Role</label></th>
					<td ><select id="role" name="role">
							<option value="customer" selected="selected">Customer</option>
							<option value="shop_manager">Shop Manager</option>		
						</select>
					</td>
				</tr>
				</tbody>
				</table>
				
				<?php  
				   if(isset($wpuef_htmlHelper) && isset($wpuef_user_model)): 
				
					if(isset($_POST['wpuef_options']) && isset($data_source[ 'ID' ]) && method_exists($wpuef_user_model,'save_fields') )
						$wpuef_user_model->save_fields($_POST['wpuef_options'], $data_source[ 'ID' ] );
		
					if(!$this->edit_mode && method_exists($wpuef_htmlHelper,'render_register_form_extra_fields_wccm'))
						$wpuef_htmlHelper->render_register_form_extra_fields_wccm();
					else if( method_exists($wpuef_htmlHelper,'render_edit_table_with_extra_fields'))
						$wpuef_htmlHelper->render_edit_table_with_extra_fields($data_source[ 'ID' ]);
				endif; ?>
				
				<?php if(!$this->edit_mode): ?>
				<div class="email-notification-box">
					<h4><?php  esc_html_e('Send an email to customer with login info?', 'woocommerce-customers-manager');?></h4>
					<select name="wccm-send-notification-email">
					  <option value="no"><?php  esc_html_e('No', 'woocommerce-customers-manager');?></option>
					  <option value="yes" <?php if(WCCM_Options::get_option('add_customer_page_send_login_info_email', false)) echo " selected='selected' "; ?>><?php  esc_html_e('Yes', 'woocommerce-customers-manager');?></option>
					</select>
				</div>
			<?php endif; ?>
				<p class="submit">				
					<input type="submit" value="<?php 
							if(!$this->edit_mode)
								_e('Add new customer', 'woocommerce-customers-manager');
							else
								_e('Update customer', 'woocommerce-customers-manager');
						?>" class="button button-primary add-update_user-button" name="createuser"></input>
				</p>
			</form>
			</div>
			<div class="clear"></div>
		</div><!-- wpbody-content -->
		<div class="clear"></div>
		 <?php
	 }
}
?>