<?php 
class WCCM_CustomerGuestList
{
	var $filter_by_product_id = 0;
	var $customer_emails = 0;
	
	public function __construct()
	{
	}
	public function render_page()
	{
		
		global $wp_scripts;//useless
		
		
		$hide_not_purchasing_guest_customers = WCCM_Options::get_option('hide_not_purchasing_guest_customers');
		if(isset($_GET['filter-by-product']))
			$this->filter_by_product_id = $_GET['filter-by-product'];
		
		if(isset($_REQUEST['wccm_customers_emails']))
		{
			$this->customer_emails =gzinflate(base64_decode(strtr($_REQUEST['wccm_customers_emails'], '-_', '+/')));
			$this->customer_emails = $this->customer_emails == "" ? 'none' : $this->customer_emails;
		}
		
		$wp_scripts->queue = array();//useless
		wp_enqueue_script( 'jquery' ); //useless
		wp_enqueue_script( 'jquery-ui-progressbar' );
		wp_enqueue_script( 'jquery-ui-datepicker' );
		wp_enqueue_style('jquery-style',  WCCM_PLUGIN_PATH.'/css/jquery-ui.css');
		wp_enqueue_style('jquery-datatable',  WCCM_PLUGIN_PATH.'/css/jquery.dataTables.min.css');
		wp_enqueue_style('customer-export-css',  WCCM_PLUGIN_PATH.'/css/customer-guests-list.css');
		wp_enqueue_style('wccm-common',  WCCM_PLUGIN_PATH.'/css/common.css');   
		
		wp_register_script('ajax-guests-list',  WCCM_PLUGIN_PATH.'/js/admin-guests-list-ajax.js', array( 'jquery' ), time()); 
		$js_options = array(
				'security' => wp_create_nonce('wccm_admin_customer_export_page'),
				'hide_not_purchasing_guest_customers' => $hide_not_purchasing_guest_customers,
				'filter_by_emails' => $this->customer_emails,
				'admin_url' => admin_url('edit.php'),
				'product_filter_id' => $this->filter_by_product_id	
		);
		wp_localize_script( 'ajax-guests-list', 'wccm', $js_options );
		wp_enqueue_script( 'ajax-guests-list');
		wp_enqueue_script('data-table',  WCCM_PLUGIN_PATH.'/js/jquery.dataTables.min.js', array( 'jquery' )); 
		
		
		
		?>
		<h2 class="nav-tab-wrapper">
		<?php 
			$escaped_emails_attr = isset($_REQUEST['wccm_customers_emails']) ? esc_attr($_REQUEST['wccm_customers_emails']) : ""; 
			$escaped_ids_attr = isset($_REQUEST['wccm_customers_ids']) ? esc_attr($_REQUEST['wccm_customers_ids']) : ""; 
		?>
		<a class='nav-tab' href='?page=woocommerce-customers-manager<?php if($this->filter_by_product_id >0) echo '&filter-by-product='.$this->filter_by_product_id; if(isset($_REQUEST['wccm_customers_ids'])) echo '&wccm_customers_ids='.sanitize_text_field($escaped_ids_attr);  if(isset($_REQUEST['wccm_customers_emails'])) echo '&wccm_customers_emails='.sanitize_text_field($escaped_emails_attr); echo '&wccm_already_encoded=yes'; ?>'>Registered</a>
		<a class='nav-tab nav-tab-active' href='?page=woocommerce-customers-manager&action=wccm-guests-list<?php if($this->filter_by_product_id >0) echo '&filter-by-product='.$this->filter_by_product_id; if(isset($escaped_ids_attr)) echo '&wccm_customers_ids='.sanitize_text_field($escaped_ids_attr); if(isset($_REQUEST['wccm_customers_emails'])) echo '&wccm_customers_emails='.sanitize_text_field($escaped_emails_attr);?>'>Guests</a>
		</h2>
		
        <h2><?php esc_html_e('Guests List', 'woocommerce-customers-manager'); ?> </h2>
		
		<div id="progress-container">
			<h3 id="ajax-progress-title"><?php  esc_html_e('Progress', 'woocommerce-customers-manager');?></h3>
			<div id="ajax-progress"></div>
			<div id="progressbar"></div>
		</div>
		<div id="guest-customer-list">
			<button class="button button-primary" id="export-button"><?php  esc_html_e('Export selected customers', 'woocommerce-customers-manager');?></button>		
			<button class="button" id="convert-button"><?php  esc_html_e('Convert selected customers', 'woocommerce-customers-manager');?></button>		
			<p><?php wccm_html_escape_allowing_special_tags(__('<strong>NOTE ON GUEST TO REGISTERED CONVERSION FEATURE:</strong> In case the billing email used by the guest is already associated to a register user, the guest orders will be assigned to that registered user', 'woocommerce-customers-manager'));?></p>
			<table id="guests-table" class="display striped" cellspacing="0" width="100%" >
				<thead>
						<tr>
							<th scope="col" class="manage-column column-select" style=""><input type="checkbox" class="all-customers-select" ></input><?php  ?></th>
							<th scope="col" class="manage-column column-conversion" style=""><?php  esc_html_e('Conversion', 'woocommerce-customers-manager');?><br/>
																							<input type="checkbox" class="all-guest-customer-email-option-toggle" ><small ><?php  esc_html_e('Toggle email sending option', 'woocommerce-customers-manager');?></small></input> </th>
							<th scope="col" class="manage-column column-name sortable desc" style=""><?php  esc_html_e('Name', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-surname sortable desc" style=""><?php  esc_html_e('Surname', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-address" style=""><?php  esc_html_e('Address (billing)', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-address" style=""><?php  esc_html_e('Address (shipping)', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-address" style=""><?php  esc_html_e('Phone', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-email sortable desc" style=""><?php  esc_html_e('Email', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-orders sortable desc" style=""><?php  esc_html_e('Orders', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-total_spent sortable desc" style=""><?php  esc_html_e('Total spent', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-first_order_date" style=""><?php  esc_html_e('First order date', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-last_order_date sortable desc" style=""><?php  esc_html_e('Last order date', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-order_list" style=""><?php  esc_html_e('Order list', 'woocommerce-customers-manager');?></th>
						</tr>
				</thead>

				<tfoot>
						<tr>
							<th scope="col" class="manage-column column-select" style=""><input type="checkbox" class="all-customers-select" ></input></th>
							<th scope="col" class="manage-column column-conversion" style=""><?php  esc_html_e('Conversion', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-name sortable desc" style=""><?php  esc_html_e('Name', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-surname sortable desc" style=""><?php  esc_html_e('Surname', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-address" style=""><?php  esc_html_e('Address (billing)', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-address" style=""><?php  esc_html_e('Address (shipping)', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-address" style=""><?php  esc_html_e('Phone', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-email sortable desc" style=""><?php  esc_html_e('Email', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-orders sortable desc" style=""><?php  esc_html_e('Orders', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-total_spent sortable desc" style=""><?php  esc_html_e('Total spent', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-first_order_date" style=""><?php  esc_html_e('First order date', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-last_order_date sortable desc" style=""><?php  esc_html_e('Last order date', 'woocommerce-customers-manager');?></th>
							<th scope="col" class="manage-column column-order_list" style=""><?php  esc_html_e('Order list', 'woocommerce-customers-manager');?></th>
						</tr>
				</tfoot>

				<tbody id="table-body">
				</tbody>
				</table>
		</div>
		<?php
	}	
}
?>