<?php 
class WCCM_EmailTemplatesConfigurator
{
	public function __construct()
	{
		$this->init_options_menu();
	}
	function init_options_menu()
	{
		if( function_exists('acf_add_options_page') ) 
		{
			 acf_add_options_sub_page(array(
				'page_title' 	=> 'Email templates configurator',
				'menu_title'	=> 'Email templates configurator',
				'parent_slug'	=> 'woocommerce-customers-manager',
				'capability' => 'manage_woocommerce' 
			));
			
			
			
			add_action( 'current_screen', array(&$this, 'cl_set_global_options_pages') );
		}
	}
	/**
	 * Force ACF to use only the default language on some options pages
	 */
	function cl_set_global_options_pages($current_screen) 
	{
	  if(!is_admin())
		  return;
	  
	   global $wccm_wpml_helper;
	  $page_ids = array(
		"customers_page_acf-options-email-templates-configurator"
	  );
	  
	  if (in_array($current_screen->id, $page_ids)) 
	  {
		$wccm_wpml_helper->switch_to_default_language();
		add_filter('acf/settings/current_language', array(&$this, 'cl_acf_set_language'), 100);
	  }
	}
	

	function cl_acf_set_language() 
	{
	  return acf_get_setting('default_language');
	}

	
}
?>