<?php

class acf_html_email_preview_field extends acf_field {


	
	function __construct() {

		$this->name     = 'html_email_preview_field';
		$this->label    = esc_html__( 'HTML Email Viewer', 'acf-order-status-selector' );
		$this->category = esc_html__( 'Content', 'acf' );
		
		parent::__construct();

	}


	
	function render_field_settings( $field ) {

		
$choices = array("guest_to_registered" =>  esc_html__('Guest to registered','acf-order-status-selector') ,
						 "customer_notification" =>  esc_html__('Customer notification','acf-order-status-selector'));
		acf_render_field_setting( $field, array(
			'label'			=> esc_html__('Select template preview','acf-order-status-selector'),
			'type'			=> 'select',
			'name'			=> 'template_preview_to_show',
			'multiple'      => false,
			'choices' => $choices
		));
	}




	function render_field( $field ) 
	{
		global $wccm_configuration_model;
		if(!isset($wccm_configuration_model) || !class_exists('WC_Emails'))
			return false;
		
		$email_configuration = $wccm_configuration_model->get_email_templates_configurations();
		$template_to_used = $field['template_preview_to_show'] == 'guest_to_registered' ? $email_configuration['guest_to_registered_email_template'] : $email_configuration['customer_notification_email_template'];
		$use_footer_and_or_header = $field['template_preview_to_show'] == 'guest_to_registered' ? $email_configuration['guest_to_registered_header_footer_inlcude'] : $email_configuration['customer_notification_header_footer_inlcude'];
		 $mail = new WC_Emails();
		$email_heading = get_bloginfo('name');
		
		echo '<div id="acf_email_previw_wrapper" style="display:block; margin:50px 0 50px 0;">';
		 if($use_footer_and_or_header == 'all' || $use_footer_and_or_header == 'all')
		echo	$mail->email_header($email_heading, $mail );
		echo $template_to_used;	
		if($use_footer_and_or_header == 'all' || $use_footer_and_or_header == 'footer')
			$mail->email_footer($mail);
		echo '</div>';
		//<!-- <iframe srcdoc="echo $template_to_used " style="height:500px; width:100%;"></iframe> -->
		 ?>
		 
		<?php
		
	}


	
	function format_value($value, $post_id, $field) {
		/* if( $field['return_value'] == 'object' )
		{
			foreach( $value as $key => $name ) {
				$value[$key] = get_role( $name );
			}
		} */
		return $value;
	}


	
	function load_value($value, $post_id, $field) {

		/* if( $field['return_value'] == 'object' )
		{
			foreach( $value as $key => $name ) {
				$value[$key] = get_role( $name );
			}
		} */

		return $value;
	}

}

new acf_html_email_preview_field();

?>
