"use strict";
var state_select_data = "";
var selected = ' selected ="selected" ';
var countries = wccm.countries;
	
jQuery(document).ready(function()
{
	
	jQuery(document).on('click', '#random_generate_password', wccm_manage_password_fields);
	if(wccm.automatically_generate_password == "true")
		jQuery('#random_generate_password').trigger('click');
	
	if(wccm.automatically_fill_billing_first_name == "true")
		jQuery(document).on('keyup', '#first_name', wccm_automatic_field_filling);
	if(wccm.automatically_fill_billing_last_name == "true")
		jQuery(document).on('keyup', '#last_name', wccm_automatic_field_filling);
	if(wccm.automatically_fill_billing_email == "true")
		jQuery(document).on('keyup', '#email', wccm_automatic_field_filling);
	
	//Countries management
	var selected_shipping_country = wccm.selected_shipping_country;
	var selected_billing_country = wccm.selected_billing_country;
	var selected_shipping_state = wccm.selected_shipping_state;
	var selected_billing_state = wccm.selected_billing_state;
	var shipping_country_select_data = "";
	var billing_country_select_data = "";

	
	jQuery(".js-role-select").select2({'width':500});
	jQuery("#shipping_as_billing").click(wccm_toggle_shipping_info_visibility);
	
	var counter = 0;
	for(var country_code in countries)
		 if (typeof countries[country_code] !== 'function')
		 {
			
			//None
			if(counter == 0)
				shipping_country_select_data += '<option value=""></option>';
			if(country_code == selected_shipping_country)
				shipping_country_select_data += '<option value="'+country_code+'" '+selected+'>'+countries[country_code].name+'</option>';
			else
				shipping_country_select_data += '<option value="'+country_code+'">'+countries[country_code].name+'</option>';
			
			if(counter == 0)
				billing_country_select_data += '<option value="" ></option>';
			if(country_code == selected_billing_country)
				billing_country_select_data += '<option value="'+country_code+'" '+selected+'>'+countries[country_code].name+'</option>';
			else
				billing_country_select_data += '<option value="'+country_code+'">'+countries[country_code].name+'</option>';
			
			counter++;
		 }
	jQuery('#billing_country').html(billing_country_select_data);
	jQuery('#shipping_country').html(shipping_country_select_data);
	create_stetes_input(selected_shipping_country, 'shipping_state', selected_shipping_state);
	create_stetes_input(selected_billing_country, 'billing_state', selected_billing_state);
	
	jQuery('#billing_country').change(function(event)
	{
		create_stetes_input(jQuery(event.target).val(), 'billing_state', null);
	});
	jQuery('#shipping_country').change(function(event)
	{
		create_stetes_input(jQuery(event.target).val(), 'shipping_state', null);
	});
});
function wccm_manage_password_fields(event)
{
	jQuery(".wccm-password-row").toggle();
}
function wccm_automatic_field_filling(event)
{
	const field_to_fill = "#billing_"+jQuery(event.currentTarget).attr('id');
	jQuery(field_to_fill).val(jQuery(event.currentTarget).val());
}


function wccm_toggle_shipping_info_visibility(event)
{
	if(jQuery("#shipping_as_billing").prop('checked'))
		jQuery(".wccm-shipping-info").addClass("wccm_hide");
	else
		jQuery(".wccm-shipping-info").removeClass("wccm_hide");
}
function create_stetes_input(country_code, selector, selected_option)
{
	state_select_data = "";
	if(typeof(countries[country_code]) !== 'undefined' && !wccm_isEmpty(countries[country_code].states))
	{
		for(var state_code in countries[country_code].states)
		{
			if(selected_option != null && selected_option == state_code)
				state_select_data += '<option value="'+state_code+'" '+selected+'>'+ countries[country_code].states[state_code]+'</option>';
			else
				state_select_data += '<option value="'+state_code+'">'+ countries[country_code].states[state_code]+'</option>';
		}
	}
	else
	{
		if(selected_option != null)
			jQuery('#'+selector+'_wrapper').html('<input type="text" id="'+selector+'" name="'+selector+'" value="'+selected_option+'">');
		else
			jQuery('#'+selector+'_wrapper').html('<input type="text" id="'+selector+'" name="'+selector+'">');
		return;
	}
	
	jQuery('#'+selector+'_wrapper').html('<select id="'+selector+'" name="'+selector+'">'+state_select_data+'</select>');

}

function wccm_isEmpty(obj) {

		// null and undefined are "empty"
		if (obj == null) return true;

		// Assume if it has a length property with a non-zero value
		// that that property is correct.
		if (obj.length > 0)    return false;
		if (obj.length === 0)  return true;

		// Otherwise, does it have any properties of its own?
		// Note that this doesn't handle
		// toString and valueOf enumeration bugs in IE < 9
		for (var key in obj) {
			if (hasOwnProperty.call(obj, key)) return false;
		}

		return true;
	}
function wccm_checkPasswordStrength( $pass1,
                                $pass2,
                                $strengthResult,
                                $submitButton,
                                blacklistArray ) 
{
	var pass1 = $pass1.val();
	var pass2 = $pass2.val();
 
	// Reset the form & meter
	$submitButton.attr( 'disabled', 'disabled' );
		$strengthResult.removeClass( 'short bad good strong' );
 
	// Extend our blacklist array with those from the inputs & site data
	blacklistArray = blacklistArray.concat( wp.passwordStrength.userInputBlacklist() )
 
	// Get the password strength
	var strength = wp.passwordStrength.meter( pass1, blacklistArray, pass2 );
 
	// Add the strength meter results
	switch ( strength ) {
 
		case 2:
			$strengthResult.addClass( 'bad' ).html( pwsL10n.bad );
			break;
 
		case 3:
			$strengthResult.addClass( 'good' ).html( pwsL10n.good );
			break;
 
		case 4:
			$strengthResult.addClass( 'strong' ).html( pwsL10n.strong );
			break;
 
		case 5:
			$strengthResult.addClass( 'short' ).html( pwsL10n.mismatch );
			break;
 
		default:
			$strengthResult.addClass( 'short' ).html( pwsL10n.short );
 
	}
 
	// The meter function returns a result even if pass2 is empty,
	// enable only the submit button if the password is strong and
	// both passwords are filled up
	if ( '' !== pass2.trim() ) {
		$submitButton.removeAttr( 'disabled' );
	}
 
	return strength;
}
							 
							